{{
**********************************
* jvmEngine - executes bytecodes *
**********************************
}}


CON
  'first 64
  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  'next 64
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC_W2            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77


OBJ
  comm:          "jvmComm"    'communication port object
  jd:            "jvmDataAsm" 'jvm memory access object

  jStack:        "jvmStack"
{
  jConst:        "jvmConst"
  jLoad:         "jvmLoad"
  jStore:        "jvmStore"
  jCompareJump:  "jvmCompareJump"
  jInvoke:       "jvmInvoke"
  jMath:         "jvmMath"
  jArray:        "jvmArray"
  jObject:       "jvmObject"
  jSubReturn:    "jvmSubReturn"
  jLogic:        "jvmLogic"
  jConvert:      "jvmConvert"
}

VAR

  long  EngineCog
  long  JemCode                 'communication with assembly cog
                                'put a jemcode <> 0 and byte code
                                'is handled by assembly code
                                'it's zero if byte code was processed

                              
PUB start

  stop
  PtrJvmVars := jd.getPtrJvmVars
  PtrJemCode := @JemCode
  PtrJemCodeJmpTable := @JemCodeJmpTable
  EngineCog := cognew(@engineEntry, 0) + 1


PUB stop

  if EngineCog
    cogstop(EngineCog~ - 1)


PUB doBytecode: value | state,c
{{ Execute a bytecode }}
  state := jd.getActivity
  case state
    jd#kRun    : 'JVM running
                 c := doStep
                 if jd.mustNotifyStepDone
                   comm.notifyStepDone
                 return -32768
    jd#kBreak  : 'JVM reached breakpoint
                 'wait for IDE to send debug command (run/step/stop)
                 return -32768
    jd#kPassive: 'JVM was running but has stopped (exception,stopped,end)
                 if jd.mustStep
                   c := doStep
                   if jd.mustNotifyStepDone
                     comm.notifyStepDone
                 return -32768
    jd#kJog    : 'appears not to be used
                 'so change state to kPassive
                 jd.setActivity(jd#kPassive)
                 return -32768

  return -32768


PRI doStep: value
{{ perform a step }}
  JemCode := jd.readJavaByte(jd.getJvmPC)
  if JemCode == Jem_NOP
    jStack.jb_nop

  repeat until JemCode == 0


{{
PRI doStep: value | jemcode
{ perform a step }
  jemcode := jd.readJavaByte(jd.getJvmPC)
  if jemcode < Jem_INSTANCEOF
    case jemcode
      Jem_NOP:             jStack.jb_nop
      Jem_ICONST_M1:       jConst.jb_iconst_m1
      Jem_ICONST_0:        jConst.jb_iconst_0
      Jem_ICONST_1:        jConst.jb_iconst_1
      Jem_ICONST_2:        jConst.jb_iconst_2
      Jem_ICONST_3:        jConst.jb_iconst_3
      Jem_ICONST_4:        jConst.jb_iconst_4
      Jem_ICONST_5:        jConst.jb_iconst_5
      Jem_BIPUSH:          jConst.jb_bipush
      Jem_SIPUSH:          jConst.jb_sipush
      Jem_ILOAD:           jLoad.jb_iload
      Jem_ILOAD_0:         jLoad.jb_iload_0
      Jem_ILOAD_1:         jLoad.jb_iload_1
      Jem_ILOAD_2:         jLoad.jb_iload_2
      Jem_ILOAD_3:         jLoad.jb_iload_3
      Jem_ISTORE:          jStore.jb_istore
      Jem_ISTORE_0:        jStore.jb_istore_0
      Jem_ISTORE_1:        jStore.jb_istore_1
      Jem_ISTORE_2:        jStore.jb_istore_2
      Jem_ISTORE_3:        jStore.jb_istore_3
      Jem_IFEQ:            jCompareJump.jb_ifeq
      Jem_IFNE:            jCompareJump.jb_ifne
      Jem_IFLT:            jCompareJump.jb_iflt
      Jem_IFLE:            jCompareJump.jb_ifle
      Jem_IFGT:            jCompareJump.jb_ifgt
      Jem_IFGE:            jCompareJump.jb_ifge
      Jem_IF_ICMPEQ:       jCompareJump.jb_if_icmpeq
      Jem_IF_ICMPNE:       jCompareJump.jb_if_icmpne
      Jem_IF_ICMPLT:       jCompareJump.jb_if_icmplt
      Jem_IF_ICMPGE:       jCompareJump.jb_if_icmpge
      Jem_IF_ICMPGT:       jCompareJump.jb_if_icmpgt
      Jem_IF_ICMPLE:       jCompareJump.jb_if_icmple
      Jem_IF_ACMPEQ:       jCompareJump.jb_if_acmpeq
      Jem_IF_ACMPNE:       jCompareJump.jb_if_acmpne
      Jem_IRETURN:         jSubReturn.jb_ireturn
      Jem_RETURN:          jSubReturn.jb_return
      Jem_INVOKEVIRTUAL:   jInvoke.jb_invokevirtual
      Jem_INVOKESTATIC:    jInvoke.jb_invokestatic
      Jem_GETSTATIC:       jObject.jb_getstatic
      Jem_PUTSTATIC:       jObject.jb_putstatic
      Jem_POP:             jStack.jb_pop
      Jem_POP2:            jStack.jb_pop2
      Jem_DUP:             jStack.jb_dup
      Jem_DUP_X1:          jStack.jb_dup_x1
      Jem_DUP_X2:          jStack.jb_dup_x2
      Jem_DUP2:            jStack.jb_dup2
      Jem_DUP2_X1:         jStack.jb_dup2_x1
      Jem_DUP2_X2:         jStack.jb_dup2_x2
      Jem_SWAP:            jStack.jb_swap
      Jem_IADD:            jMath.jb_iadd
      Jem_ISUB:            jMath.jb_isub
      Jem_INEG:            jMath.jb_ineg
      Jem_IOR:             jLogic.jb_ior
      Jem_ISHL:            jLogic.jb_ishl
      Jem_ISHR:            jLogic.jb_ishr
      Jem_IUSHR:           jLogic.jb_iushr
      Jem_IAND:            jLogic.jb_iand
      Jem_IXOR:            jLogic.jb_ixor
      Jem_I2B:             jConvert.jb_i2b
      Jem_GOTO:            jCompareJump.jb_goto
      Jem_INVOKEINTERFACE: 'not used by linker
      Jem_ARRAYLENGTH:     jArray.jb_arraylength
      Jem_ATHROW:          jInvoke.jb_athrow
      Jem_CHECKCAST:       jObject.jb_checkcast
      other:

  else
    case jemcode
      Jem_INSTANCEOF:      jObject.jb_instanceof
      Jem_WIDE:            'not used by linker
      Jem_IINC:            jStore.jb_iinc
      Jem_GETFIELD:        jObject.jb_getfield
      Jem_PUTFIELD:        jObject.jb_putfield
      Jem_NEW:             jObject.jb_new
      Jem_NEWARRAY:        jArray.jb_newarray
      Jem_ANEWARRAY:       jArray.jb_anewarray
      Jem_IALOAD:          jArray.jb_iaload
      Jem_IASTORE:         jArray.jb_iastore
      Jem_BALOAD:          jArray.jb_baload
      Jem_BASTORE:         jArray.jb_bastore
      Jem_LDC:             jConst.jb_ldc
      Jem_LDC_W:           jConst.jb_ldc_w
      Jem_LDC_W2:          'not used by linker
      Jem_IMUL:            jMath.jb_imul
      Jem_IDIV:            jMath.jb_idiv
      Jem_IREM:            jMath.jb_irem
      Jem_JSR:             'not used by linker
      Jem_RET:             'not used by linker
      Jem_TABLESWITCH:     jCompareJump.jb_tableswitch
      Jem_LOOKUPSWITCH:    jCompareJump.jb_lookupswitch
      other:
}}
DAT
{{
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
                        A S S E M B L Y   S E C T I O N

}}
engineEntry             org     0

sendReady               xor     _jemcode,_jemcode
                        wrlong  _jemcode,PtrJemCode
:wait4jemcode           rdlong  _jemcode,PtrJemCode     'wait for next jemcode
                        tjz     _jemcode,#:wait4jemcode
                        cmp     _jemcode,#Jem_INVOKESTATIC  wc
        if_a            jmp     #:wait4jemcode          'not handled by this decoder
                        mov     Tmp,PtrJemCodeJmpTable
                        add     Tmp,_jemcode
                        rdword  Tmp,Tmp                 'get address of jemcode handler
                        jmp     Tmp                     'handle byte code

{{
############################## JEMCODE HANDLER ################################
}}
{{
_______________________________________________________________________________
function: jb_iconst_M1()
Push the integer constant -1.

}}
jb_iconst_M1            mov     Param1,MASK_WORD
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_0()
Push the integer constant 0.

}}
jb_iconst_0             mov     Param1,#0
jb_iconst_X             call    #push
                        call    #incJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iconst_1()
Push the integer constant 1.

}}
jb_iconst_1             mov     Param1,#1
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_2()
Push the integer constant 2.

}}
jb_iconst_2             mov     Param1,#2
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_3()
Push the integer constant 3.

}}
jb_iconst_3             mov     Param1,#3
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_4()
Push the integer constant 4.

}}
jb_iconst_4             mov     Param1,#4
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_5()
Push the integer constant 5.

}}
jb_iconst_5             mov     Param1,#5
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_bipush()
Push a 1-byte signed integer.

}}
jb_bipush               call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaByte
                        mov     Param1,jvmResult
                        call    #b2i
jb_xpush                call    #push
                        call    #incJvmPC2
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_sipush()
Push a 2-byte signed integer.

}}
jb_sipush               call    #getJvmPC
                        add     jvmPC,#1
                        mov     Param1,jvmPC
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        jmp     #jb_xpush


{{
_______________________________________________________________________________
function: jb_iload()
Load integer from local variable.

}}
jb_iload                call    #getJvmPC
                        add     jvmPC,#1
                        mov     Param1,jvmPC
                        call    #readJavaByte
                        shl     jvmResult,#1
jb_iload_x              call    #getJvmFP
                        mov     Param1,jvmFP
                        add     Param1,jvmResult
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        call    #push
                        call    #incJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iload_0()
Load integer from local variable with index 0.

}}
jb_iload_0              mov     jvmResult,#0
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_1()
Load integer from local variable with index 1.

}}
jb_iload_1              mov     jvmResult,#1 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_2()
Load integer from local variable with index 2.

}}
jb_iload_2              mov     jvmResult,#2 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_3()
Load integer from local variable with index 3.

}}
jb_iload_3              mov     jvmResult,#3 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_4()
Load integer from local variable with index 4.

}}
jb_iload_4              mov     jvmResult,#4 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_5()
Load integer from local variable with index 5.

}}
jb_iload_5              mov     jvmResult,#5 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_istore()
Store integer into local variable.

}}
jb_istore               call    #getJvmPC
                        add     jvmPC,#1
                        mov     Param1,jvmPC
                        call    #readJavaByte
                        shl     jvmResult,#1
                        mov     Tmp,jvmResult
jb_istore_x             call    #pop
                        mov     Param2,jvmResult
                        call    #getJvmFP
                        mov     Param1,jvmFP
                        add     Param1,Tmp
                        call    #writeJavaIntBE
                        call    #incJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_istore_0()
Store integer into local variable with index 0.

}}
jb_istore_0             mov     Tmp,#0
                        jmp     #jb_istore_x

{{
_______________________________________________________________________________
function: jb_istore_1()
Store integer into local variable with index 1.

}}
jb_istore_1             mov     Tmp,#1 * jd#JVM_INT_SIZE
                        jmp     #jb_istore_x
{{
_______________________________________________________________________________
function: jb_istore_2()
Store integer into local variable with index 2.

}}
jb_istore_2             mov     Tmp,#2 * jd#JVM_INT_SIZE
                        jmp     #jb_istore_x
{{
_______________________________________________________________________________
function: jb_istore_3()
Store integer into local variable with index 3.

}}
jb_istore_3             mov     Tmp,#3 * jd#JVM_INT_SIZE
                        jmp     #jb_istore_x

{{
_______________________________________________________________________________
function: jb_ifeq()
Branch if equal to 0.

}}
jb_ifeq                 call    #jb_ifx
jb_if_icmpeqx
        if_z            call    #addN2JvmPC
        if_nz           call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifne()
Branch if not equal to 0.

}}
jb_ifne                 call    #jb_ifx
jb_if_icmpnex
        if_nz           call    #addN2JvmPC
        if_z            call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iflt()
Branch if less than 0.

}}
jb_iflt                 call    #jb_ifx
jb_if_icmpltx
        if_c            call    #addN2JvmPC
        if_nc           call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifle()
Branch if less than or equal to 0.

}}
jb_ifle                 call    #jb_ifx
jb_if_icmplex
        if_c_OR_z       call    #addN2JvmPC
        if_nc_OR_nz     call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifgt()
Branch if greater than 0.

}}
jb_ifgt                 call    #jb_ifx
jb_if_icmpgtx
        if_nc           call    #addN2JvmPC
        if_c            call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifge()
Branch if greater than or equal to 0.

}}
jb_ifge                 call    #jb_ifx
jb_if_icmpgex
        if_nc_OR_z      call    #addN2JvmPC
        if_c_OR_nz      call    #incJvmPC3
                        jmp     #sendReady

jb_ifx                  call    #pop
                        mov     Param1,jvmResult
                        call    #i2l
                        mov     Tmp,Param1
                        cmps    Tmp,#0  wc, wz
jb_if_icmpN             call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE
                        mov     jvmTmp,jvmResult
jb_ifx_ret
jb_if_icmpN_ret         ret

{{
_______________________________________________________________________________
function: jb_if_acmpeq()
Branch if object references are equal.

}}
jb_if_acmpeq

{{
_______________________________________________________________________________
function: jb_if_icmpeq()
Branch if integers v1 and v2 are equal.

}}
jb_if_icmpeq            call    #jb_if_icmpx
                        jmp     #jb_if_icmpeqx

{{
_______________________________________________________________________________
function: jb_if_acmpne()
Branch if object references are not equal.

}}
jb_if_acmpne

{{
_______________________________________________________________________________
function: jb_if_icmpne()
Branch if integers v1 and v2 are not equal.

}}
jb_if_icmpne            call    #jb_if_icmpx
                        jmp     #jb_if_icmpnex

{{
_______________________________________________________________________________
function: jb_if_icmplt()
Branch if integer v1 is less than integer v2.

}}
jb_if_icmplt            call    #jb_if_icmpx
                        jmp     #jb_if_icmpltx

{{
_______________________________________________________________________________
function: jb_if_icmpge()
Branch if integer v1 is greater than or equal to integer v2.

}}
jb_if_icmpge            call    #jb_if_icmpx
                        jmp     #jb_if_icmpgex

{{
_______________________________________________________________________________
function: jb_if_icmpgt()
Branch if integer v1 is greater than integer v2.

}}
jb_if_icmpgt            call    #jb_if_icmpx
                        jmp     #jb_if_icmpgtx

{{
_______________________________________________________________________________
function: jb_if_icmple()
Branch if integer v1 is less than or equal to integer v2.

}}
jb_if_icmple            call    #jb_if_icmpx
                        jmp     #jb_if_icmplex

jb_if_icmpx             call    #pop
                        mov     Param1,jvmResult
                        call    #i2l
                        mov     Param2,Param1
                        call    #pop
                        mov     Param1,jvmResult
                        call    #i2l
                        cmps    Param1,Param2  wc, wz
                        call    #jb_if_icmpN
jb_if_icmpx_ret         ret

{{
_______________________________________________________________________________
function: jb_ireturn()
Return integer from function.

}}
jb_ireturn              call    #pop
                        call    #jb_returnInternal      'discard frame
                        mov     Param1,jvmResult
                        call    #push
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_return()
Return (void) from method.

}}
jb_return               call    #jb_returnInternal
                        jmp     #sendReady

jb_returnInternal       call    #getJvmMP
                        mov     Param1,jvmMP
                        call    #readJavaByte
                        mov     Tmp,jvmResult
                        add     jvmMP,#1
                        call    #readJavaByte
                        add     Tmp,jvmResult
                        call    #getJvmFP
                        mov     jvmSP,jvmFP
                        add     jvmSP,Tmp
                        mov     Param1,jvmSP
                        call    #readJavaIntBE
                        mov     jvmMP,jvmResult
                        call    #updateJvmMP
                        mov     Param1,jvmSP
                        add     Param1,#jd#JVM_INT_SIZE
                        call    #readJavaIntBE
                        mov     jvmFP,jvmResult
                        call    #updateJvmFP
                        mov     Param1,jvmSP
                        add     Param1,#2 * jd#JVM_INT_SIZE
                        call    #readJavaIntBE
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC
                        sub     jvmSP,Tmp
                        call    #updateJvmSP
jb_returnInternal_ret   ret

{{
_______________________________________________________________________________
function: jb_invokevirtual()
Invoke method based on runtime type.
  byte2 is offset to begin of class method table (so if byte = $2D and class method table = $60, method header = $8D)
  byte1 is offset to sp to find object reference (so if sp = $3FF6 and byte1 = $04 then the aref is at $3FF6-$04 = $3FF2)

}}
jb_invokevirtual        call    #getJvmSP
                        call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaByte           'get offset from sp where aref is stored
                        mov     jvmFP,jvmSP
                        sub     jvmFP,jvmResult         'calculate address of possibly new frame
                        mov     Param1,jvmFP
                        call    #readJavaIntBE          'get aref
                        mov     Param1,jvmResult
                        call    #readJavaIntBE          'get address of class descriptor
                        mov     Param1,jvmPC
                        add     Param1,#2
                        add     Param1,jvmResult
                        call    #readJavaByte           'get address of method descriptor
                        mov     Tmp,jvmResult
                        jmp     #invokeInternal
                        
{{
_______________________________________________________________________________
function: jb_invokestatic()
Invoke a class (static) method.
  byte1 and byte2 form 16bits address to method header: addr = (byte1<<8)|(byte2) 

}}
jb_invokestatic         call    #getJvmSP
                        mov     jvmFP,jvmSP
                        call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE
                        mov     Tmp,jvmResult
                        mov     Param1,Tmp
                        add     Param1,jd#JVM_PARAMETERS
                        call    #readJavaByte
                        sub     jvmFP,jvmResult
invokeInternal          mov     Param1,Tmp
                        add     Param1,#jd#JVM_FLAGS
                        call    #readJavaByte
                        tjnz    jvmResult,#:chkNative
                        'not native
                        mov     Param1,Tmp           
                        add     Param1,jd#JVM_LOCALS
                        call    #readJavaByte
                        add     jvmSP,jvmResult
                        call    #getJvmMP
                        mov     Param2,jvmMP
                        mov     Param1,jvmSP
                        call    #writeJavaIntBE         'save old mp
                        add     Param1,#jd#JVM_INT_SIZE
                        mov     jvmResult,jvmFP
                        call    #getJvmFP
                        mov     Param2,jvmFP
                        call    #writeJavaIntBE         'save old fp
                        mov     jvmFP,jvmResult
                        add     Param1,#jd#JVM_INT_SIZE
                        mov     Param2,jvmPC
                        add     Param2,#3
                        call    #writeJavaIntBE         'save old pc (= return address)
                        call    #updateJvmFP            'set new fp
                        mov     jvmMP,Tmp
                        call    #updateJvmMP            'set new mp
                        mov     jvmSP,Param1
                        add     jvmSP,#jd#JVM_INT_SIZE
                        call    #updateJvmSP            'set new sp
                        mov     Param1,jvmMP
                        add     Param1,#jd#JVM_CODE
                        call    #readJavaIntBE
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC            'set new pc
                        jmp     #sendReady
                        
:chkNative              cmp     jvmResult,#$80  wz
        if_nz           jmp     #sendReady
                        mov     Param1,Tmp
                        add     Param1,jd#JVM_CODE
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        call    #doNative
                        call    #incJvmPC3
                        jmp     #sendReady

{{
############################### JVM FUNCTIONS #################################
The parameters of jvm functions are passed via variables like ParamX where X
is the number of parameter.

}}
{{
_______________________________________________________________________________
function: doNative(nativeFin)
Auxiliary function (not bytecode): Meaning: Pop word from the stack.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
doNative                'not implemented yet
doNative_ret            ret

{{
_______________________________________________________________________________
function: pop()
Auxiliary function (not bytecode): Meaning: Pop word from the stack.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
pop                     call    #getJvmSP
                        call    #decJvmSP2
                        mov     Param1,jvmSP
                        call    #readJavaIntBE
pop_ret                 ret

{{
_______________________________________________________________________________
function: push(value)
Push word onto the stack.

param:  Param1 = value
uses:   jvmTmp
}}
push                    mov     Param2,Param1
                        call    #getJvmSP
                        mov     Param1,jvmSP
                        call    #writeJavaIntBE
                        call    #incJvmSP2
push_ret                ret

{{
_______________________________________________________________________________
function: readJavaByte(address)
read value from java program.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaByte            call    #getJavaProg
                        mov     jvmTmp,javaProg
                        add     jvmTmp,Param1
                        rdbyte  jvmResult,jvmTmp
                        and     jvmResult,#$FF
readJavaByte_ret        ret

{{
_______________________________________________________________________________
function: readJavaIntBE(address)
read value from java program using big endian.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaIntBE           mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        rdbyte  jvmResult,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        shl     jvmResult,#8
                        rdbyte  jvmTmp,jvmTmp
                        or      jvmResult,jvmTmp
                        and     jvmResult,MASK_WORD
readJavaIntBE_ret       ret

{{
_______________________________________________________________________________
function: writeJavaIntBE(address, value)
write value to java program using big endian.

param:  Param1 = address
        Param2 = value
uses:   jvmTmp
}}
writeJavaIntBE          mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        ror     Param2,#8
                        wrbyte  Param2,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        rol     Param2,#8
                        wrbyte  Param2,jvmTmp
writeJavaIntBE_ret      ret

{{

############################# INTERNAL FUNCTIONS ##############################
}}
{{
_______________________________________________________________________________
function: b2i(value)
value is a signed 1 byte constant: if value < 128 const = value
                                   else const = value | $FF00.

param:  Param1 = value
return: Param1 = converted value
}}
b2i                     cmp     Param1,#128  wc
        if_nc           or      Param1,#MASK_WORD_HBYTE
b2i_ret                 ret

{{
_______________________________________________________________________________
function: i2l(value)
value is a signed 2 byte constant: if value < 32768 const = value
                                   else const = value | $FFFF_0000.

param:  Param1 = value
return: Param1 = converted value
}}
i2l                     cmp     Param1,K32768  wc
        if_nc           or      Param1,MASK_LONG_HWORD
i2l_ret                 ret

{{
_______________________________________________________________________________
function: getJavaProg()
get address of java program storage area from main memory.

return: javaProg
uses:   jvmVar
}}
getJavaProg             mov     jvmVar,#jd#varJavaProg
                        call    #getJvmVar
                        mov     javaProg,jvmVar
getJavaProg_ret         ret

{{
_______________________________________________________________________________
function: getJvmFP()
get frame pointer from main memory.

return: jvmFP
uses:   jvmVar
}}
getJvmFP                mov     jvmVar,#jd#varJvmFP
                        call    #getJvmVar
                        mov     jvmFP,jvmVar
getJvmFP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmFP()
update frame pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmFP             mov     jvmTmp,jvmFP
                        mov     jvmVar,#jd#varJvmFP
                        call    #updateJvmVar
updateJvmFP_ret         ret
{{
_______________________________________________________________________________
function: getJvmMP()
get method pointer from main memory.

return: jvmMP
uses:   jvmVar
}}
getJvmMP                mov     jvmVar,#jd#varJvmMP
                        call    #getJvmVar
                        mov     jvmMP,jvmVar
getJvmMP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmMP()
update method pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmMP             mov     jvmTmp,jvmMP
                        mov     jvmVar,#jd#varJvmMP
                        call    #updateJvmVar
updateJvmMP_ret         ret

{{
_______________________________________________________________________________
function: getJvmPC()
get program counter from main memory.

return: jvmPC
uses:   jvmVar
}}
getJvmPC                mov     jvmVar,#jd#varJvmPC
                        call    #getJvmVar
                        mov     jvmPC,jvmVar
getJvmPC_ret            ret

{{
_______________________________________________________________________________
function: incJvmPC()
increments program counter by 1.

uses:   jvmTmp, jvmVar
}}
incJvmPC                add     jvmPC,#1
updateJvmPC             mov     jvmTmp,jvmPC
                        mov     jvmVar,#jd#varJvmPC
                        call    #updateJvmVar
incJvmPC_ret
incJvmPC2_ret
incJvmPC3_ret
addN2JvmPC_ret
updateJvmPC_ret         ret

{{
_______________________________________________________________________________
function: incJvmPC2()
increments program counter by 2.

uses:   jvmTmp, jvmVar
}}
incJvmPC2               add     jvmPC,#2
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: incJvmPC3()
increments program counter by 3.

uses:   jvmTmp, jvmVar
}}
incJvmPC3               add     jvmPC,#3
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: addN2JvmPC(diff)
adds given diff to program counter.

param:  jvmTmp = diff to add
uses:   jvmVar
}}
addN2JvmPC              add     jvmPC,jvmTmp
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: getJvmSP()
get stack pointer from main memory.

return: jvmSP
uses:   jvmVar
}}
getJvmSP                mov     jvmVar,#jd#varJvmSP
                        call    #getJvmVar
                        mov     jvmSP,jvmVar
getJvmSP_ret            ret

{{
_______________________________________________________________________________
function: decJvmSP2()
decrements stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
decJvmSP2               sub     jvmSP,#2
                        jmp     #updateJvmSP

{{
_______________________________________________________________________________
function: incJvmSP2()
increments stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
incJvmSP2               add     jvmSP,#2
updateJvmSP             mov     jvmTmp,jvmSP
                        mov     jvmVar,#jd#varJvmSP
                        call    #updateJvmVar
decJvmSP2_ret
incJvmSP2_ret
updateJvmSP_ret         ret

{{
_______________________________________________________________________________
function: getJvmVar(variable)
get a jvm variable from main memory.

param:  jvmVar = variable to get
return: jvmVar = value of jvm variable
}}
getJvmVar               add     jvmVar,PtrJvmVars
                        rdword  jvmVar,jvmVar
                        and     jvmVar,MASK_WORD
getJvmVar_ret           ret

{{
_______________________________________________________________________________
function: updateJvmVar(variable, value)
updates a jvm variable in main memory with the given value.

param:  jvmVar = variable to update
        jvmTmp = value to set
uses:   jvmVar
}}
updateJvmVar            add     jvmVar,PtrJvmVars
                        wrword  jvmTmp,jvmVar
updateJvmVar_ret        ret


K32768                  long    $8000
MASK_WORD               long    $FFFF
MASK_WORD_HBYTE         long    $FF00
MASK_LONG_HWORD         long    $FFFF_0000
PtrJemCodeJmpTable      long    0-0
PtrJemCode              long    0-0
PtrJvmVars              long    0-0

                        long    $88338833[144]          'currently are 144 longs left
_jemcode                res     0
Param1                  res     0
Param2                  res     0
Tmp                     res     0
jvmResult               res     0
jvmTmp                  res     0
jvmVar                  res     0
javaProg                res     0
jvmFP                   res     0
jvmMP                   res     0
jvmPC                   res     0
jvmSP                   res     0
                        fit     $1F0
'
DAT
JemCodeJmpTable
                        word    (@jb_iconst_M1 - @engineEntry)/4     'Jem_ICONST_M1
                        word    (@jb_iconst_0 - @engineEntry)/4      'Jem_ICONST_0
                        word    (@jb_iconst_1 - @engineEntry)/4      'Jem_ICONST_1
                        word    (@jb_iconst_2 - @engineEntry)/4      'Jem_ICONST_2
                        word    (@jb_iconst_3 - @engineEntry)/4      'Jem_ICONST_3
                        word    (@jb_iconst_4 - @engineEntry)/4      'Jem_ICONST_4
                        word    (@jb_iconst_5 - @engineEntry)/4      'Jem_ICONST_5
                        word    (@jb_bipush - @engineEntry)/4        'Jem_BIPUSH
                        word    (@jb_sipush - @engineEntry)/4        'Jem_SIPUSH
                        word    (@jb_iload - @engineEntry)/4         'Jem_ILOAD
                        word    (@jb_iload_0 - @engineEntry)/4       'Jem_ILOAD_0
                        word    (@jb_iload_1 - @engineEntry)/4       'Jem_ILOAD_1
                        word    (@jb_iload_2 - @engineEntry)/4       'Jem_ILOAD_2
                        word    (@jb_iload_3 - @engineEntry)/4       'Jem_ILOAD_3
                        word    (@jb_istore - @engineEntry)/4        'Jem_ISTORE
                        word    (@jb_istore_0 - @engineEntry)/4      'Jem_ISTORE_0
                        word    (@jb_istore_1 - @engineEntry)/4      'Jem_ISTORE_1
                        word    (@jb_istore_2 - @engineEntry)/4      'Jem_ISTORE_2
                        word    (@jb_istore_3 - @engineEntry)/4      'Jem_ISTORE_3
                        word    (@jb_ifeq - @engineEntry)/4          'Jem_IFEQ
                        word    (@jb_ifne - @engineEntry)/4          'Jem_IFNE
                        word    (@jb_iflt - @engineEntry)/4          'Jem_IFLT
                        word    (@jb_ifle - @engineEntry)/4          'Jem_IFLE
                        word    (@jb_ifgt - @engineEntry)/4          'Jem_IFGT
                        word    (@jb_ifge - @engineEntry)/4          'Jem_IFGE
                        word    (@jb_if_icmpeq - @engineEntry)/4     'Jem_IF_ICMPEQ
                        word    (@jb_if_icmpne - @engineEntry)/4     'Jem_IF_ICMPNE
                        word    (@jb_if_icmplt - @engineEntry)/4     'Jem_IF_ICMPLT
                        word    (@jb_if_icmpge - @engineEntry)/4     'Jem_IF_ICMPGE
                        word    (@jb_if_icmpgt - @engineEntry)/4     'Jem_IF_ICMPGT
                        word    (@jb_if_icmple - @engineEntry)/4     'Jem_IF_ICMPLE
                        word    (@jb_if_acmpeq - @engineEntry)/4     'Jem_IF_ACMPEQ
                        word    (@jb_if_acmpne - @engineEntry)/4     'Jem_IF_ACMPNE
                        word    (@jb_ireturn - @engineEntry)/4       'Jem_IRETURN
                        word    (@jb_return - @engineEntry)/4        'Jem_RETURN
                        word    (@jb_invokevirtual - @engineEntry)/4 'Jem_INVOKEVIRTUAL
                        word    (@jb_invokestatic - @engineEntry)/4  'Jem_INVOKESTATIC
'